package ru.dbotthepony.mc.otm.block.entity.cable

import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet
import ru.dbotthepony.mc.otm.capability.receiveEnergy
import ru.dbotthepony.mc.otm.core.ifPresentK
import ru.dbotthepony.mc.otm.core.math.Decimal
import ru.dbotthepony.mc.otm.graph.GraphNodeList

class EnergyCableGraph : GraphNodeList<EnergyCableBlockEntity.Node, EnergyCableGraph>() {
	val livelyNodes = ObjectOpenHashSet<EnergyCableBlockEntity.Node>()

	override fun onNodeRemoved(node: EnergyCableBlockEntity.Node) {
		livelyNodes.remove(node)
	}

	override fun onNodeAdded(node: EnergyCableBlockEntity.Node) {
		livelyNodes.add(node)
	}

	fun receiveEnergy(howMuch: Decimal, simulate: Boolean): Decimal {
		val itr = livelyNodes.iterator()
		var received = Decimal.ZERO
		var residue = howMuch

		for (node in itr) {
			var hit = false

			for (side in node.sides.values) {
				if (side.isEnabled) {
					side.neighbour.get().ifPresentK {
						if (it !is EnergyCableBlockEntity.CableSide) {
							hit = true

							val thisReceived = it.receiveEnergy(residue, simulate)
							received += thisReceived
							residue -= thisReceived

							if (!residue.isPositive) return received
						}
					}
				}
			}

			if (!hit) {
				itr.remove()
			}
		}

		return received
	}
}
